/*
 * BluSunrize
 * Copyright (c) 2017
 *
 * This code is licensed under "Blu's License of Common Sense"
 * Details can be found in the license file in the root folder of this project
 */

package blusunrize.immersiveengineering.common.util.network;

import blusunrize.immersiveengineering.common.items.ItemIEShield;
import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumHand;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;

public class MessageMagnetEquip implements IMessage
{
	String player;
	int fetchSlot;
	public MessageMagnetEquip(String player, int fetch)
	{
		this.player = player;
		this.fetchSlot = fetch;
	}
	public MessageMagnetEquip()
	{
	}

	@Override
	public void fromBytes(ByteBuf buf)
	{
		this.player = ByteBufUtils.readUTF8String(buf);
		this.fetchSlot = buf.readInt();
	}

	@Override
	public void toBytes(ByteBuf buf)
	{
		ByteBufUtils.writeUTF8String(buf, this.player);
		buf.writeInt(this.fetchSlot);
	}

	public static class Handler implements IMessageHandler<MessageMagnetEquip, IMessage>
	{
		@Override
		public IMessage onMessage(MessageMagnetEquip message, MessageContext ctx)
		{
			EntityPlayer player = FMLCommonHandler.instance().getMinecraftServerInstance().func_184103_al().func_152612_a(message.player);
			if(player!=null)
			{
				ItemStack held = player.func_184586_b(EnumHand.OFF_HAND);
				if(message.fetchSlot>=0)
				{
					ItemStack s = player.field_71071_by.field_70462_a.get(message.fetchSlot);
					if(!s.func_190926_b()&&s.func_77973_b() instanceof ItemIEShield&&((ItemIEShield)s.func_77973_b()).getUpgrades(s).func_74767_n("magnet"))
					{
						((ItemIEShield)s.func_77973_b()).getUpgrades(s).func_74768_a("prevSlot", message.fetchSlot);
						player.field_71071_by.field_70462_a.set(message.fetchSlot, held);
						player.func_184611_a(EnumHand.OFF_HAND, s);
					}
				}
				else
				{
					int prevSlot = ((ItemIEShield)held.func_77973_b()).getUpgrades(held).func_74762_e("prevSlot");
					ItemStack s = player.field_71071_by.field_70462_a.get(prevSlot);
					player.field_71071_by.field_70462_a.set(prevSlot, held);
					player.func_184611_a(EnumHand.OFF_HAND, s);
					((ItemIEShield)held.func_77973_b()).getUpgrades(held).func_82580_o("prevSlot");
				}
			}
			return null;
		}
	}
}
